import java.io.*;
import java.nio.*;
import java.nio.channels.*;
import java.util.*;
import java.net.*;

/**
 * This is little command line java proggie for sending some data over
 * a java.nio TCP socket.
 */
public class NIOSend {
    public static void main(String args[])
    {
       //make some data to send
       byte []data = new byte[1600];
       byte []filler = new String("Idn't dat special?  ").getBytes();
       for(int i=0; i<data.length; i++)
          data[i] = filler[i%filler.length];
      try {
        Selector selector = Selector.open();
        InetSocketAddress isa = new InetSocketAddress("10.127.61.10", 999 );

        //Connecting on address.
        System.out.println("Connecting to address");
        SocketChannel cc = SocketChannel.open();
        cc.configureBlocking(false);
        cc.connect(isa);
        cc.register(selector, SelectionKey.OP_CONNECT);

        //select and handle events that come in
        System.out.println("Entering select loop");
        ByteBuffer ob = ByteBuffer.wrap(data);
        while( true ) {
            if( selector.select(5000) > 0 ) {
                Set keys = selector.selectedKeys();
                for( Iterator i = keys.iterator(); i.hasNext(); i.remove() ) {
                    SelectionKey key = (SelectionKey)i.next();
                    
                    //handle connection events
                    if( key.isConnectable() ) {
                        System.out.print("Got OP_CONNECT event...");
                        if( cc != key.channel() )
                            throw new Exception("Wrong connect channel");
                        if( cc.isConnectionPending() )
                            cc.finishConnect();
                        String ip = cc.socket().getInetAddress().
                            getHostAddress();
                        System.out.println("Finished connecting to " + ip);
                    }
                }
            }
            else {
                //write some data
                System.out.print("Writing some data...");
                int n = cc.write(ob);
                String ip = cc.socket().getInetAddress().getHostAddress();
                System.out.println("Wrote " + n + " bytes to " + ip);
                ob.rewind();
            }
        }
      } catch (Exception ex) {
          System.out.println("---Exception occured---");
          ex.printStackTrace();
      }
    }
}
